<?
/*--------------------------------------------------------------------
   KorWeblog :: Highly Customizable Weblog/CMS
   Copyright (C) 2001-2004 by Im Eunjea <eunjea@kldp.org>
   For detail of license and/or other info, see the file doc/COPYING.
   http://weblog.kldp.org
----------------------------------------------------------------------

LICENSE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
----------------------------------------------------------------------*/

include("include/common.inc.php");

KWL_CheckLocalReferer(1);

$url = rawurldecode($url);
$img_size = @getimagesize($url);
$type = $img_size[2];
$supported_types = get_supported_image_types();

if (in_array($type, $supported_types)) {
   switch($type) {
      case 1:
         $img = imagecreatefromgif($url);
         break;
      case 2:
         $img = imagecreatefromjpeg($url);
         break;
      case 3:
         $img = imagecreatefrompng($url);
         break;
   }

   $orig['width'] = imagesx($img);
   $orig['height'] = imagesy($img);

   $new['width'] = $CONF['thumb_size'];
   $new['height'] = intval($orig['height']/($orig['width']/$new['width']));

   if (gd_version() >= 2) {
      $thumb = @ImageCreateTrueColor($new['width'],$new['height']);
   } else {
      $thumb = ImageCreate($new['width'],$new['height']);
   }

   imagecopyresized($thumb,$img,0,0,0,0,$new['width'],$new['height'],$orig['width'],$orig['height']);

   header("Content-type: ". $img_size['mime']);
   switch($type) {
      case 1:
         imagegif($thumb);
      break;
      case 2:
         imagejpeg($thumb,'',90);
      break;
      case 3:
         imagepng($thumb);
      break;
   }
   imagedestroy($thumb);
} else {
   header("Content-type: ". $img_size['mime']);
   $fp = fopen($url, "rb");
   fpassthru($fp);
}

function get_supported_image_types() {
   $types = array();

   if (extension_loaded('gd')) {
      if (function_exists('imagegif')) {
         $types[] = '1';
      }
      if (function_exists('imagejpeg')) {
         $types[] = '2';
      }
      if (function_exists('imagepng')) {
         $types[] = '3';
      }
   }
	return ($types);
}

function gd_version() {
   static $gd_version_number = null;
   if ($gd_version_number === null) {
      ob_start();
      phpinfo(8);
      $module_info = ob_get_contents();
      ob_end_clean();
      if (preg_match("/\bgd\s+version\b[^\d\n\r]+?([\d\.]+)/i",
               $module_info,$matches)) {
         $gd_version_number = $matches[1];
      } else {
         $gd_version_number = 0;
      }
   }
   return $gd_version_number;
}
?>
