<?
class RSS {

   var $channeltags = array ('title', 'link', 'description', 'language', 'copyright', 'managingEditor', 'webMaster', 'pubDate', 'lastBuildDate', 'rating', 'docs');
   var $itemtags = array('title', 'link', 'description', 'author', 'category', 'comments', 'enclosure', 'guid', 'pubDate', 'source');
   var $imagetags = array('title', 'url', 'link', 'width', 'height');
   var $textinputtags = array('title', 'description', 'name', 'link');

   function my_preg_match ($pattern, $subject) {
      preg_match($pattern, $subject, $out);
      return !empty($out[1]) ? trim($out[1]) : '';
   }

   function unhtmlentities ($string) {
      $trans_tbl = get_html_translation_table (HTML_ENTITIES);
      $trans_tbl = array_flip ($trans_tbl);
      return strtr ($string, $trans_tbl);
   }

   function parse($rss_content) {

      $result['encoding'] = $this->my_preg_match("'encoding=[\'\"](.*?)[\'\"]'si", $rss_content);

      preg_match("'<channel.*?>(.*?)</channel>'si", $rss_content, $out_channel);
      foreach($this->channeltags as $channeltag) {
         $temp = $this->my_preg_match("'<$channeltag.*?>(.*?)</$channeltag>'si", $out_channel[1]);
         if ($temp != '') $result[$channeltag] = $temp;
      }

      preg_match("'<textinput(|[^>]*[^/])>(.*?)</textinput>'si", $rss_content, $out_textinfo);
      if (!empty($out_textinfo[2])) {
         foreach($this->textinputtags as $textinputtag) {
            $temp = $this->my_preg_match("'<$textinputtag.*?>(.*?)</$textinputtag>'si", $out_textinfo[2]);
            if ($temp != '') $result['textinput_'.$textinputtag] = $temp;
         }
      }

      preg_match("'<image.*?>(.*?)</image>'si", $rss_content, $out_imageinfo);
      if (!empty($out_imageinfo[1])) {
         foreach($this->imagetags as $imagetag) {
            $temp = $this->my_preg_match("'<$imagetag.*?>(.*?)</$imagetag>'si", $out_imageinfo[1]);
            if ($temp != '') $result['image_'.$imagetag] = $temp;
         }
      }

      preg_match_all("'<item(| .*?)>(.*?)</item>'si", $rss_content, $items);
      $rss_items = $items[2];
      $result['items_count'] = count($items[1]);
      $i = 0;
      $result['items'] = array();
      foreach($rss_items as $rss_item) {
         foreach($this->itemtags as $itemtag) {
            $temp = $this->my_preg_match("'<$itemtag.*?>(.*?)</$itemtag>'si", $rss_item);
            if ($temp != '') {
               $temp = preg_replace("/<!\[CDATA\[(.*)]]>/i","\\1",$temp);
               $result['items'][$i][$itemtag] = $temp;
            }
         }

         /*
         if ($result['items'][$i]['description'])
            $result['items'][$i]['description'] = strip_tags($this->unhtmlentities(strip_tags($result['items'][$i]['description'])));
         */
         $i++;
      }
      return $result;
   }

   function import_rss($url) {
      return $this->parse(KWL_Get_Content($url));
   }

}
?>
